> ## Documentation Index
> Fetch the complete documentation index at: https://docs.roark.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a scenario

> Creates a new simulation scenario for the authenticated project.



## OpenAPI

````yaml /api-reference/openapi.documented.json post /v1/simulation/scenario
openapi: 3.1.0
info:
  title: Roark Analytics API
  description: >-
    The Roark Analytics API gives you access to the same API that powers the
    award winning Roark Analytics platform.
  version: 1.0.0
servers:
  - description: Production
    url: https://api.roark.ai
security:
  - Bearer: []
tags:
  - name: Agent
  - name: Agent Endpoint
  - name: Call
  - name: Chat
  - name: Metric
  - name: Metric Policy
  - name: Metric Collection Job
  - name: Simulation Persona
  - name: Simulation Scenario
  - name: Simulation Run Plan
  - name: Simulation Run Plan Job
  - name: Simulation Job
  - name: HTTP Request Definition
  - name: Webhook
  - name: Issue
  - name: Knowledge Base
  - name: Call Analysis
  - name: Health
paths:
  /v1/simulation/scenario:
    post:
      tags:
        - Simulation Scenario
      summary: Create a scenario
      description: Creates a new simulation scenario for the authenticated project.
      operationId: postV1SimulationScenario
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  minLength: 1
                  description: Name of the scenario (used as the START node content)
                steps:
                  type: array
                  items:
                    type: object
                    properties:
                      type:
                        type: string
                        enum:
                          - AGENT_TURN
                          - CUSTOMER_TURN
                          - CUSTOMER_FIRST_MESSAGE
                          - CUSTOMER_SILENCE
                          - CUSTOMER_DTMF
                          - VOICEMAIL
                          - SCENARIO_LINK
                        description: The type of this step
                      content:
                        type: string
                        description: The content/text of the step
                      linkedScenarioId:
                        type: string
                        format: uuid
                        description: >-
                          ID of the scenario to link to (required for
                          SCENARIO_LINK type steps)
                      dtmfDigits:
                        type: string
                        description: >-
                          DTMF digits to send (for CUSTOMER_DTMF type steps,
                          e.g. 1w2w3#). Valid characters: 0-9, *, #, w/W for
                          pauses.
                      silenceDurationSeconds:
                        type: integer
                        description: >-
                          Duration of silence in seconds (for CUSTOMER_SILENCE
                          type steps)
                    required:
                      - type
                      - content
                    title: CreateScenarioStepInput
                    description: A step to include when creating a scenario
                  minItems: 1
                  description: >-
                    Ordered list of steps for the scenario (at least one step is
                    required)
              required:
                - name
                - steps
              title: CreateScenarioInput
              description: Input for creating a new scenario
      responses:
        '201':
          description: The created scenario
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: object
                    properties:
                      id:
                        type: string
                        format: uuid
                        description: Unique identifier of the scenario
                      name:
                        type:
                          - string
                          - 'null'
                        description: Name of the scenario (from the start node content)
                      description:
                        type:
                          - string
                          - 'null'
                        description: Description of the scenario
                      steps:
                        type: array
                        items:
                          type: object
                          properties:
                            nodeId:
                              type: string
                              format: uuid
                              description: >-
                                Unique identifier of the step node (use this for
                                update/delete operations)
                            type:
                              type: string
                              enum:
                                - START
                                - AGENT_TURN
                                - CUSTOMER_TURN
                                - CUSTOMER_FIRST_MESSAGE
                                - CUSTOMER_SILENCE
                                - CUSTOMER_DTMF
                                - VOICEMAIL
                                - SCENARIO_LINK
                              description: Type of step in the scenario
                            content:
                              type:
                                - string
                                - 'null'
                              description: Content/text of the step
                            linkedScenarioId:
                              type:
                                - string
                                - 'null'
                              format: uuid
                              description: >-
                                ID of the linked scenario (only for
                                SCENARIO_LINK type steps)
                            dtmfDigits:
                              type:
                                - string
                                - 'null'
                              description: >-
                                DTMF digits to send during this step (e.g.
                                1w2w3#). Valid characters: 0-9, *, #, w/W for
                                pauses.
                            silenceDurationSeconds:
                              type:
                                - integer
                                - 'null'
                              description: >-
                                Duration of silence in seconds (only for
                                CUSTOMER_SILENCE type steps)
                          required:
                            - nodeId
                            - type
                            - content
                        description: >-
                          Ordered list of steps in the scenario (excludes the
                          START node)
                      createdAt:
                        type: string
                        description: Creation timestamp in ISO 8601 format
                      updatedAt:
                        type: string
                        description: Last update timestamp in ISO 8601 format
                    required:
                      - id
                      - name
                      - description
                      - steps
                      - createdAt
                      - updatedAt
                required:
                  - data
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Validation error
              example:
                type: validation
                code: invalid_parameter
                message: The request was invalid
                param: email
          description: Bad Request
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Authentication error
              example:
                type: authentication
                code: unauthorized
                message: Authentication required
          description: Unauthorized
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                description: Server error
              example:
                type: internal
                code: internal_error
                message: Internal server error
          description: Internal Server Error
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Roark from '@roarkanalytics/sdk';

            const client = new Roark({
              bearerToken: process.env['ROARK_API_BEARER_TOKEN'], // This is the default and can be omitted
            });

            const simulationScenario = await client.simulationScenario.create({
              name: 'x',
              steps: [{ content: 'content', type: 'AGENT_TURN' }],
            });

            console.log(simulationScenario.data);
        - lang: Python
          source: |-
            import os
            from roark_analytics import Roark

            client = Roark(
                bearer_token=os.environ.get("ROARK_API_BEARER_TOKEN"),  # This is the default and can be omitted
            )
            simulation_scenario = client.simulation_scenario.create(
                name="x",
                steps=[{
                    "content": "content",
                    "type": "AGENT_TURN",
                }],
            )
            print(simulation_scenario.data)
components:
  schemas:
    ErrorResponse:
      type: object
      properties:
        type:
          type: string
          enum:
            - validation
            - authentication
            - forbidden
            - not_found
            - conflict
            - rate_limit
            - internal
          description: The error type category
          examples:
            - validation
            - authentication
        code:
          type: string
          description: Machine-readable error code identifier
          examples:
            - invalid_parameter
            - missing_required_field
            - unauthorized
        message:
          type: string
          description: Human-readable error message
          examples:
            - The request was invalid
            - Authentication required
        param:
          type: string
          description: The parameter that caused the error (if applicable)
          examples:
            - email
            - user_id
        details:
          description: Additional error context information
      required:
        - type
        - code
        - message
  securitySchemes:
    Bearer:
      type: http
      scheme: bearer
      bearerFormat: JWT

````